## dolfin 2019.2.0~git20210928.3eacdb4

=== CMakeLists.txt ===
# Require CMake 2.8
cmake_minimum_required(VERSION 3.5)

# Find DOLFIN config file (not used here, but check that benchmarks will be
# able to find it
find_package(DOLFIN REQUIRED)

# If config file is found, add all demo sub-directories, else print helper
# message
if (DOLFIN_FOUND)

  # Build list of all cpp directories
  file( GLOB_RECURSE list "main.cpp")
  list( SORT list )
  string(REGEX REPLACE "/main.cpp" "" list "${list}")

  # Add each C++ code directory
  foreach (cpp_dir ${list})
    #message(STATUS "Add C++ benchmark: ${cpp_dir}")
    add_subdirectory(${cpp_dir})
  endforeach()

  # Add fem/speedup/cpp manually (no main.cpp so not picked up automatically)
  add_subdirectory(fem/speedup/cpp)

else()

  message(STATUS "Could not locate DOLFINConfig.cmake file. Did you do 'make install' for the DOLFIN library and set the appropriate paths (source <build_dir>/dolfin.conf)?")

endif()

=== adaptivity/CMakeLists.txt ===
set(HEADERS
  adapt.h
  AdaptiveLinearVariationalSolver.h
  AdaptiveNonlinearVariationalSolver.h
  adaptivesolve.h
  dolfin_adaptivity.h
  ErrorControl.h
  Extrapolation.h
  GenericAdaptiveVariationalSolver.h
  GoalFunctional.h
  marking.h
  TimeSeries.h
  PARENT_SCOPE)

set(SOURCES
  adapt.cpp
  AdaptiveLinearVariationalSolver.cpp
  AdaptiveNonlinearVariationalSolver.cpp
  adaptivesolve.cpp
  ErrorControl.cpp
  Extrapolation.cpp
  GenericAdaptiveVariationalSolver.cpp
  GoalFunctional.cpp
  marking.cpp
  TimeSeries.cpp
  PARENT_SCOPE)

=== graph/CMakeLists.txt ===
set(HEADERS
  BoostGraphColoring.h
  BoostGraphOrdering.h
  CSRGraph.h
  dolfin_graph.h
  GraphBuilder.h
  GraphColoring.h
  Graph.h
  ParMETIS.h
  SCOTCH.h
  ZoltanInterface.h
  PARENT_SCOPE)

set(SOURCES
  BoostGraphOrdering.cpp
  GraphBuilder.cpp
  GraphColoring.cpp
  ParMETIS.cpp
  SCOTCH.cpp
  ZoltanInterface.cpp
  PARENT_SCOPE)

=== mesh/CMakeLists.txt ===
set(HEADERS
  BoundaryComputation.h
  BoundaryMesh.h
  Cell.h
  CellType.h
  DistributedMeshTools.h
  dolfin_mesh.h
  DomainBoundary.h
  DynamicMeshEditor.h
  Edge.h
  Face.h
  FacetCell.h
  Facet.h
  HexahedronCell.h
  IntervalCell.h
  LocalMeshData.h
  LocalMeshValueCollection.h
  MeshColoring.h
  MeshConnectivity.h
  MeshData.h
  MeshDomains.h
  MeshEditor.h
  MeshEntity.h
  MeshEntityIteratorBase.h
  MeshEntityIterator.h
  MeshFunction.h
  MeshGeometry.h
  Mesh.h
  MeshHierarchy.h
  MeshOrdering.h
  MeshPartitioning.h
  MeshQuality.h
  MeshRelation.h
  MeshRenumbering.h
  MeshSmoothing.h
  MeshTopology.h
  MeshTransformation.h
  MeshValueCollection.h
  MeshView.h
  MultiMesh.h
  PeriodicBoundaryComputation.h
  PointCell.h
  QuadrilateralCell.h
  SubDomain.h
  SubMesh.h
  SubsetIterator.h
  TetrahedronCell.h
  TopologyComputation.h
  TriangleCell.h
  Vertex.h
  PARENT_SCOPE)

set(SOURCES
  BoundaryComputation.cpp
  BoundaryMesh.cpp
  Cell.cpp
  CellType.cpp
  DistributedMeshTools.cpp
  DynamicMeshEditor.cpp
  Edge.cpp
  Face.cpp
  FacetCell.cpp
  Facet.cpp
  HexahedronCell.cpp
  IntervalCell.cpp
  LocalMeshData.cpp
  MeshColoring.cpp
  MeshConnectivity.cpp
  Mesh.cpp
  MeshData.cpp
  MeshDomains.cpp
  MeshEditor.cpp
  MeshEntity.cpp
  MeshFunction.cpp
  MeshGeometry.cpp
  MeshHierarchy.cpp
  MeshOrdering.cpp
  MeshPartitioning.cpp
  MeshQuality.cpp
  MeshRenumbering.cpp
  MeshSmoothing.cpp
  MeshTopology.cpp
  MeshTransformation.cpp
  MeshView.cpp
  MultiMesh.cpp
  PeriodicBoundaryComputation.cpp
  PointCell.cpp
  QuadrilateralCell.cpp
  SubDomain.cpp
  SubMesh.cpp
  TetrahedronCell.cpp
  TopologyComputation.cpp
  TriangleCell.cpp
  PARENT_SCOPE)

=== unit/cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(dolfin-tests)

find_package(DOLFIN REQUIRED)
include(${DOLFIN_USE_FILE})

# Prepare "Catch" library for other executables
set(CATCH_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/catch)

add_library(Catch INTERFACE)
target_include_directories(Catch INTERFACE ${CATCH_INCLUDE_DIR})

# Make test executable
set(TEST_SOURCES
  ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/common/SubSystemsManager.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/function/Expression.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/geometry/ConvexTriangulation.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/geometry/IntersectionConstruction.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/io/XMLMeshData.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/io/XMLMeshValueCollection.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/la/LinearOperator.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/la/Vector.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mesh/Mesh.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mesh/MeshColoring.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mesh/MeshFunction.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mesh/MeshValueCollection.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mesh/MultiMesh.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/parameter/Parameters.cpp
  )

add_executable(unittests ${TEST_SOURCES})
target_link_libraries(unittests PRIVATE Catch dolfin)
target_include_directories(unittests PRIVATE ${DOLFIN_SOURCE_DIR} ${DOLFIN_SOURCE_DIR}/dolfin ${DOLFIN_BINARY_DIR})

# Test target
add_test(unittests unittests)

=== debian/changelog ===
dolfin (2019.2.0~git20210928.3eacdb4-3build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 16 Mar 2022 19:22:32 +0000

dolfin (2019.2.0~git20210928.3eacdb4-3) unstable; urgency=medium

  * debian patch catch_SIGSTKSZ_libc6_2.34.patch patches catch.hpp
    setting sigStackSize to 32768 if using libc6 2.34 or later, where
    SIGSTKSZ is no longer an integer (already fixed in catch2, but
    this is vendored catch1). Adapted from catch2 upstream PR#2317,
    moderated by catch2 upstream commit c0d0a50b.
    Closes: #993516.
  * debian patch docs_local_mathjax.patch configures docs to build
    with local mathjax script.

 -- Drew Parsons <dparsons@debian.org>  Sat, 05 Feb 2022 11:14:50 +0100

dolfin (2019.2.0~git20210928.3eacdb4-2) unstable; urgency=medium

  * skip failing serial tests on hppa

 -- Drew Parsons <dparsons@debian.org>  Sun, 24 Oct 2021 15:37:25 +0200

dolfin (2019.2.0~git20210928.3eacdb4-1) unstable; urgency=medium

  * New upstream snapshot.
    - drop upper-versioned dependency on ufl (python3-ufl)
  * place INSTALLATION_BUILDDIR{_64} definitions before rules,
    to be used by override_dh_auto_clean
  * remove deprecated dolfin_utils entries from debian/copyright
  * Standards-Version: 4.6.0

 -- Drew Parsons <dparsons@debian.org>  Sat, 23 Oct 2021 11:33:15 +0200

=== debian/control ===
Source: dolfin
Section: math
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Johannes Ring <johannr@simula.no>,
 Drew Parsons <dparsons@debian.org>
Build-Depends:
 cmake (>= 3.5),
 debhelper-compat (= 13),
 dh-python,
 gfortran,
 chrpath,
 libboost-chrono-dev,
 libboost-dev (>= 1.56),
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-math-dev,
 libboost-mpi-dev,
 libboost-program-options-dev,
 libboost-serialization-dev,
 libboost-thread-dev,
 libboost-timer-dev,
 libeigen3-dev (>= 3.2.90),
 libhdf5-mpi-dev,
 libsuitesparse-dev,
 libscotch-dev,
 libxml2-dev,
 mpi-default-dev,
 petsc-dev (>= 3.7),
 slepc-dev (>= 3.7),
 python3-petsc4py,
 python3-slepc4py,
 python3-petsc4py-real,
 python3-slepc4py-real,
 petsc64-dev (>= 3.7),
 slepc64-dev (>= 3.7),
 python3-petsc4py-64-real,
 python3-slepc4py-64-real,
 pybind11-dev (>= 2.2.0),
 python3-setuptools,
 pkg-config,
 python3-all-dev,
 python3-pkg-resources,
 python3-ffc (>= 2019.2), python3-ffc (<< 2019.3),
 python3-dijitso (>= 2019.2), python3-dijitso (<< 2019.3),
 python3-numpy,
 python3-ply,
 python3-sphinx,
 python3-sphinx-rtd-theme,
 doxygen,
 graphviz,
 libjs-mathjax,
 libjs-modernizr
Standards-Version: 4.6.0
Homepage: http://fenicsproject.org
Vcs-Git: https://salsa.debian.org/science-team/fenics/dolfin.git
Vcs-Browser: https://salsa.debian.org/science-team/fenics/dolfin

Package: libdolfin-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libdolfin-dev-common (>= 2019.2.0~git20200218.027d9cc-7),
 cmake (>= 2.8.0),
 g++ | c++-compiler,
 libboost-chrono-dev,
 libboost-dev,
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-math-dev,
 libboost-mpi-dev,
 libboost-program-options-dev,
 libboost-serialization-dev,
 libboost-thread-dev,
 libboost-timer-dev,
 libdolfin2019.2 (= ${binary:Version}),
 libeigen3-dev,
 libhdf5-mpi-dev,
 libsuitesparse-dev,
 libscotch-dev,
 libxml2-dev,
 pkg-config,
 python3-ffc (>= ${fenics:Upstream-Version}), python3-ffc (<< ${fenics:Next-Upstream-Version}),
 ${petsc:Depends},
 ${misc:Depends}
Conflicts:
 libdolfin0-dev,
 libdolfin1.0-dev,
 libdolfin1.1-dev,
 libdolfin1.2-dev,
 libdolfin1.3-dev,
 libdolfin1.4-dev
Replaces:
 libdolfin0-dev,
 libdolfin1.0-dev,
 libdolfin1.1-dev,
 libdolfin1.2-dev,
 libdolfin1.3-dev,
 libdolfin1.4-dev
Description: Shared links and development files for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the development files.
 .
 This is the legacy version of DOLFIN, you may want to install the
 next-generation libdolfinx-dev (DOLFIN-X) instead.

Package: libdolfin-dev-common
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Conflicts:
 libdolfin0-dev,
 libdolfin1.0-dev,
 libdolfin1.1-dev,
 libdolfin1.2-dev,
 libdolfin1.3-dev,
 libdolfin1.4-dev
Replaces:
 libdolfin0-dev,
 libdolfin1.0-dev,
 libdolfin1.1-dev,
 libdolfin1.2-dev,
 libdolfin1.3-dev,
 libdolfin1.4-dev,
 libdolfin-dev (<< 2019.2.0~git20200218.027d9cc-7)
Breaks:
 libdolfin-dev (<< 2019.2.0~git20200218.027d9cc-7)
Description: Common header files for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the common development header files.
 .
 This is the legacy version of DOLFIN, you may want to install the
 next-generation libdolfinx-dev (DOLFIN-X) instead.

Package: libdolfin2019.2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: dolfin-doc, python3-dolfin
Description: Shared libraries for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the shared libraries.

Package: python3-dolfin
Section: python
Architecture: any
Depends: python3-dolfin-real | python3-dolfin64-real,
 python3-dijitso (>= ${fenics:Upstream-Version}), python3-dijitso (<< ${fenics:Next-Upstream-Version}),
 python3-ffc (>= ${fenics:Upstream-Version}), python3-ffc (<< ${fenics:Next-Upstream-Version}),
 python3-ufl (>= ${fenics:Upstream-Version}),
 python3-numpy,
 ${python3-petsc4py:Depends},
 python3-ply,
 python3-pybind11 (>= ${pybind11:Upstream-Version}), python3-pybind11 (<< ${pybind11:Next-Upstream-Version}),
 python3-six,
 python3-sympy,
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends}
Suggests: dolfin-doc
Description: Base Python interface for DOLFIN (Python 3)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This is the base package depending on specific dolfin builds. By
 default the version built against the preferred version of PETSc in
 /usr/lib/petsc is selected (with 32-bit indexing, but the
 alternative version (64-bit PETSc) can be selected by setting the
 environment variable PETSC_DIR.
 .
 This is the legacy version of DOLFIN, you may want to install the
 next-generation python3-dolfinx (DOLFIN-X) instead.

Package: python3-dolfin-real
Section: python
Architecture: any
Depends:
 libdolfin-dev (= ${binary:Version}),
 libdolfin2019.2 (= ${binary:Version}),
 ${python3-petsc4py-real:Depends},
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends}
Recommends: python3-dolfin (= ${binary:Version})
Description: Python interface for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the Python interface for DOLFIN (Python 3)
 build against the default version of PETSc (with 32-bit indexing)
 .
 This is the legacy version of DOLFIN, you may want to install the
 next-generation python3-dolfinx (DOLFIN-X) instead.

Package: libdolfin64-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libdolfin-dev-common,
 cmake (>= 2.8.0),
 g++ | c++-compiler,
 libboost-chrono-dev,
 libboost-dev,
 libboost-filesystem-dev,
 libboost-iostreams-dev,
 libboost-math-dev,
 libboost-mpi-dev,
 libboost-program-options-dev,
 libboost-serialization-dev,
 libboost-thread-dev,
 libboost-timer-dev,
 libdolfin64-2019.2 (= ${binary:Version}),
 libeigen3-dev,
 libhdf5-mpi-dev,
 libsuitesparse-dev,
 libscotch-dev,
 libxml2-dev,
 pkg-config,
 python3-ffc (>= ${fenics:Upstream-Version}), python3-ffc (<< ${fenics:Next-Upstream-Version}),
 ${petsc64:Depends},
 ${misc:Depends}
Description: Shared links and dev files for DOLFIN (64-bit indexing)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the development files for DOLFIN built against
 64-bit PETSc (64-bit indexing).
 .
 This is the legacy version of DOLFIN, you may want to install the
 next-generation libdolfinx-dev (DOLFIN-X) instead.

Package: libdolfin64-2019.2
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: dolfin-doc, python3-dolfin64-real
Description: Shared libraries for DOLFIN (64-bit indexing)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the shared libraries for DOLFIN built against
 64-bit PETSc (64-bit indexing).

Package: python3-dolfin64-real
Section: python
Architecture: any
Depends:
 libdolfin64-dev (= ${binary:Version}),
 libdolfin64-2019.2 (= ${binary:Version}),
 ${python3-petsc4py-64-real:Depends},
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends}
Recommends: python3-dolfin (= ${binary:Version})
Description: Python interface for DOLFIN (with 64-bit PETSc integers)
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains the Python interface for DOLFIN (Python 3)
 build against 64-bit PETSc (64-bit indexing)
 .
 This is the legacy version of DOLFIN, you may want to install the
 next-generation python3-dolfinx (DOLFIN-X) instead.

Package: dolfin-doc
Architecture: all
Section: doc
Depends:
 libdolfin-dev (>= ${source:Version}),
 python3-dolfin (>= ${source:Version}),
 libjs-mathjax,
 ${misc:Depends},
 ${sphinxdoc:Depends}
Recommends: python3-matplotlib
Suggests: cmake (>= 2.8.0)
Description: Documentation and demo programs for DOLFIN
 DOLFIN is the Python and C++ interface of the FEniCS project for the
 automated solution of differential equations, providing a consistent
 PSE (Problem Solving Environment) for solving ordinary and partial
 differential equations. Key features include a simple, consistent and
 intuitive object-oriented API; automatic and efficient evaluation of
 variational forms; automatic and efficient assembly of linear
 systems; and support for general families of finite elements.
 .
 This package contains documentation and demo programs for DOLFIN.

Package: dolfin-bin
Architecture: all
Depends:
 python3-dolfin (>= ${source:Version}),
 ${misc:Depends},
 ${python3:Depends}
Description: Executable scripts for DOLFIN

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

DEB_SOURCE_PACKAGE := $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/\+dfsg.*$$//p')

FENICS_RELEASE_VERSION=$(DEB_STRIPPED_UPSTREAM_VERSION)
FENICS_MAJOR_VERSION=$(shell echo $(FENICS_RELEASE_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
FENICS_MINOR_VERSION=$(shell echo $(FENICS_RELEASE_VERSION) | sed "s/^\([^.]*\)\.\([^.]*\)\..*$$/\2/")
FENICS_VERSION=$(FENICS_MAJOR_VERSION).$(FENICS_MINOR_VERSION)
FENICS_NEXT_VERSION=$(FENICS_MAJOR_VERSION).$(shell echo $$(( $(FENICS_MINOR_VERSION) + 1 )) )

# dolfin depends on the pybind11 version it was built against,
# if pybind11.h will be used in C++ code fragments in python scripts.
# But pybind11 follows semantic versioning, so should have backwards compatibility
# with minor and patch version updates.
# Extract pybind11 version from pybind11-dev
PYBIND11_DEB_VERSION=$(shell dpkg -s pybind11-dev | awk '/Version:/ {print $$2}')
# extract the current pybind11 version X.Y.Z (drop epoch and debian package version)
PYBIND11_UPSTREAM_VERSION=$(shell echo $(PYBIND11_DEB_VERSION) | sed "s/^.[^:]*://; s/-[^-]*$$//")
PYBIND11_X_VERSION=$(shell echo $(PYBIND11_UPSTREAM_VERSION) | sed "s/^\([^.]*\).*/\1/")
PYBIND11_X_Y_VERSION=$(shell echo $(PYBIND11_UPSTREAM_VERSION) | sed "s/^\(.*\)\.\([^.]*\)$$/\1/")
PYBIND11_VERSION=$(PYBIND11_X_Y_VERSION)
PYBIND11_NEXT_VERSION=$(shell echo $$(( $(PYBIND11_X_VERSION) + 1 )) )

# Allow test programs that use OpenMPI to run
export OMPI_MCA_plm_rsh_agent=/bin/false
export OMPI_MCA_btl_base_warn_component_unused=0

include /usr/share/mpi-default-dev/debian_defaults
ENABLE_MPI=ON
ifeq ($(findstring $(DEB_BUILD_ARCH),$(OPENMPI_ARCHITECTURES)),)
MPIEXEC_PARAMS=
else
MPIEXEC_PARAMS=--oversubscribe
endif

DOLFIN_HOME = $(CURDIR)/$(DEB_SRCDIR)
USCAN_DESTDIR := $(CURDIR)
PY3VERS := $(shell py3versions --requested debian/control | tac -s' ')
PYVERS = $(PY3VERS)

BUILDDIR = obj-$(DEB_HOST_GNU_TYPE)
BUILDDIR_64 = obj-$(DEB_HOST_GNU_TYPE)-64
TESTDIR = build-tests
TESTDIR_64 = build-tests-64

NPROC := $(shell nproc)
PARALLEL = $(subst parallel=,,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
N_CPU    = $(or $(PARALLEL),$(NPROC),1)
# MPI tests are set up to run on 3 processes. Spread them leanly over the available processors (don't have more than 2 tests using one processor).
# e.g. run 1 MPI test at a time over 1-3 processors, or 2 tests at a time over 4-6 processors, or 3 tests over 7-9 processors, etc.
N_MPI := 3
N_MPI_TESTS = $(shell echo $$(( ($(N_CPU)+$(N_MPI)-1)/$(N_MPI) )) )

# some tests run slow (> 1000 sec) on all arches
ARCH_ALL_SKIP_SERIAL_TEST = demo_hyperelasticity_serial demo_cahn-hilliard_serial

# hyperelasticity fails (diverges) on all arches (pivot factors too large, not enough memory assigned)
# elastodynamics passes with dpkg-buildpackage but fails with pdebuild (on amd64). Unreliable, so skip.
ARCH_ALL_SKIP_MPI_TEST = demo_hyperelasticity_mpi demo_elastodynamics_mpi

# Some arches fail the same MPI tests
# e.g. cahn-hilliard, navier-stokes, elasticity, fails or exceeds allowed time
# So skip these tests on the failing arches
ARCH_SKIP_MPI_TEST_LIST = i386 mipsel ppc64el ia64
ARCH_SKIP_MPI_TEST = demo_cahn-hilliard_mpi demo_navier-stokes_mpi demo_elasticity_mpi

# skip more MPI tests for some specific arches
ifeq (arm64, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_navier-stokes_mpi
else ifeq (mips, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_cahn-hilliard_mpi demo_stokes-iterative_mpi demo_ale_mpi demo_poisson-disc_mpi
else ifeq (mipsel, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_stokes-iterative_mpi demo_ale_mpi demo_poisson-disc_mpi
else ifeq (ppc64el, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_poisson_mpi demo_singular-poisson_mpi demo_sym-dirichlet-bc_mpi
else ifeq (ia64, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_bcs_mpi demo_biharmonic_mpi demo_built-in-meshes_mpi demo_eigenvalue_mpi
else ifeq (sparc64, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_MPI_TEST = demo_contact-vi-snes_mpi
else
  ARCH_SPECIFIC_SKIP_MPI_TEST =
endif

# m68k,mips,hppa,sparc64 need some help to pass serial tests
ifeq (m68k, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_auto-adaptive-poisson_serial demo_elasticity_serial
else ifeq (mips, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
else ifeq (mipsel, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_elastodynamics_serial demo_sym-dirichlet-bc_serial
else ifeq (hppa, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_mixed-poisson_serial demo_stokes-taylor-hood_serial demo_auto-adaptive-navier-stokes_serial demo_contact-vi-snes_serial demo_multimesh-stokes_serial
else ifeq (sparc64, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST = demo_contact-vi-snes_serial
else
  ARCH_SPECIFIC_SKIP_SERIAL_TEST =
endif


# skip slow tests (> 500-1000 sec to complete)
ifeq (armel, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_stokes-iterative_serial demo_auto-adaptive-navier-stokes_serial demo_elastodynamics_serial demo_sym-dirichlet-bc_serial demo_hyperelasticity_serial demo_cahn-hilliard_serial
else ifeq (armhf, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_elastodynamics_serial demo_sym-dirichlet-bc_serial demo_hyperelasticity_serial
else ifeq (mips, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_eigenvalue_serial demo_navier-stokes_serial demo_auto-adaptive-poisson_serial demo_stokes-taylor-hood_serial demo_auto-adaptive-navier-stokes_serial demo_curl-curl_serial demo_elasticity_serial demo_stokes-iterative_serial demo_eval_serial demo_sym-dirichlet-bc_serial demo_elastodynamics_serial demo_eigenvalue_mpi demo_navier-stokes_mpi demo_curl-curl_mpi demo_elasticity_mpi demo_elastodynamics_mpi demo_sym-dirichlet-bc_mpi
else ifeq (mipsel, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
else ifeq (alpha, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_elastodynamics_serial demo_sym-dirichlet-bc_serial demo_hyperelasticity_serial
else ifeq (hppa, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
else ifeq (m68k, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial
else ifeq (riscv64, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_elastodynamics_serial demo_sym-dirichlet-bc_serial demo_cahn-hilliard_serial demo_hyperelasticity_serial demo_cahn-hilliard_mpi demo_elastodynamics_mpi
else ifeq (sparc64, $(DEB_HOST_ARCH))
  ARCH_SKIP_SLOW_TEST = demo_cahn-hilliard_serial demo_hyperelasticity_serial demo_stokes-iterative_serial demo_cahn-hilliard_mpi demo_elastodynamics_mpi
else
  ARCH_SKIP_SLOW_TEST =
endif

empty :=
space := $(empty)$(empty)

ARCH32_LIST = armel armhf i386 mipsel powerpc x32

ARCH_SPECIFIC_SKIP_SERIAL_TEST_64 = $(ARCH_SPECIFIC_SKIP_SERIAL_TEST) demo_stokes-iterative_serial demo_curl-curl_serial
ARCH_SPECIFIC_SKIP_MPI_TEST_64 = $(ARCH_SPECIFIC_SKIP_MPI_TEST)

ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(ARCH32_LIST)$(space)))
  # these 4 tests fail in 64-bit build tests on 32-bit arches
  ARCH_SPECIFIC_SKIP_SERIAL_TEST_64 += demo_mixed-poisson_serial demo_stokes-taylor-hood_serial demo_auto-adaptive-navier-stokes_serial demo_multimesh-stokes_serial
endif
ifeq (armel, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST_64 += demo_contact-vi-snes_serial
else ifeq (armhf, $(DEB_HOST_ARCH))
  ARCH_SPECIFIC_SKIP_SERIAL_TEST_64 += demo_contact-vi-snes_serial
else ifeq (mipsel, $(DEB_HOST_ARCH))

=== debian/tests/control ===
Tests: test-dolfin-cpp,
# test-dolfin64-cpp,
Depends: @, @builddeps@,
	  libblis-pthread-dev | libopenblas-pthread-dev
Restrictions: allow-stderr

Tests: test-dolfin-python-unittest,
 test-dolfin-python-demo
# test-dolfin64-cpp,
# test-dolfin64-python-unittest,
# test-dolfin64-python-demo
Depends: @, @builddeps@,
	  python3-pytest,
	  python3-decorator,
	  python3-matplotlib,
	  python3-scipy,
	  libblis-pthread-dev | libopenblas-pthread-dev

## dolfin 2019.2.0~git20220407.d29e24d

=== debian/changelog ===
dolfin (2019.2.0~git20220407.d29e24d-6) unstable; urgency=medium

  * remove debian/tmp64 when running dh_auto_clean
  * debian/tests: skip demo_matnest on s390x

 -- Drew Parsons <dparsons@debian.org>  Wed, 07 Sep 2022 00:04:12 +0200

dolfin (2019.2.0~git20220407.d29e24d-5) unstable; urgency=medium

  * skip demo_mixed-poisson_mpi in build-time tests
  * debian patch test_import_ufl_2022.patch applies explicit ufl
    imports to .ufl files in order to work with ufl 2022.1.0
  * Standards-Version: 4.6.1

 -- Drew Parsons <dparsons@debian.org>  Sat, 11 Jun 2022 20:18:26 +0200

dolfin (2019.2.0~git20220407.d29e24d-4) unstable; urgency=medium

  * drop more flaky tests and demos

 -- Drew Parsons <dparsons@debian.org>  Mon, 18 Apr 2022 10:09:55 +0200

dolfin (2019.2.0~git20220407.d29e24d-3) unstable; urgency=medium

  * provide LD_LIBRARY_PATH to libdolfin.so when building python docs
  * Build-Depends: python3-pkgconfig and set PKG_CONFIG_PATH
    when building python docs

 -- Drew Parsons <dparsons@debian.org>  Sun, 17 Apr 2022 17:32:56 +0200

dolfin (2019.2.0~git20220407.d29e24d-2) unstable; urgency=medium

  * list dependencies for building docs under Build-Depends-Indep:
    python3-sphinx-rtd-theme, doxygen, graphviz
  * provide PYTHONPATH to newly built python module when building
    python docs
  * skip python unit test test_mixed_assembly_rank0 on i386, s390x

 -- Drew Parsons <dparsons@debian.org>  Sun, 17 Apr 2022 10:39:44 +0200

dolfin (2019.2.0~git20220407.d29e24d-1) unstable; urgency=medium

  * New upstream snapshot
    - adds Cécile Daversin-Catty's mixed-dimensional functionality
  * skip MPI demo tests in debian/tests which occasionally suffer
    race conditions in the test environment:
      block-assembly-2D2D, meshview-2D2D, meshview-3D1D

 -- Drew Parsons <dparsons@debian.org>  Thu, 14 Apr 2022 23:55:55 +0200

dolfin (2019.2.0~git20210928.3eacdb4-4) unstable; urgency=medium

  * skip test_function.py, test_function_assigner.py, and test_mesh.py
    test_shared_entities[shared_vertex-mesh_factory8] in MPI python
    unit tests (debian/tests for autopkgtest). Closes: #1008225.

 -- Drew Parsons <dparsons@debian.org>  Sun, 03 Apr 2022 15:48:51 +0200

=== debian/control ===
--- 
+++ 
@@ -39,20 +39,21 @@
  python3-slepc4py-64-real,
  pybind11-dev (>= 2.2.0),
  python3-setuptools,
- pkg-config,
+ pkg-config, python3-pkgconfig,
  python3-all-dev,
  python3-pkg-resources,
  python3-ffc (>= 2019.2), python3-ffc (<< 2019.3),
  python3-dijitso (>= 2019.2), python3-dijitso (<< 2019.3),
  python3-numpy,
  python3-ply,
- python3-sphinx,
+ python3-sphinx
+Build-Depends-Indep:
  python3-sphinx-rtd-theme,
  doxygen,
  graphviz,
  libjs-mathjax,
  libjs-modernizr
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: http://fenicsproject.org
 Vcs-Git: https://salsa.debian.org/science-team/fenics/dolfin.git
 Vcs-Browser: https://salsa.debian.org/science-team/fenics/dolfin

=== debian/rules ===
--- 
+++ 
@@ -62,7 +62,7 @@
 
 # hyperelasticity fails (diverges) on all arches (pivot factors too large, not enough memory assigned)
 # elastodynamics passes with dpkg-buildpackage but fails with pdebuild (on amd64). Unreliable, so skip.
-ARCH_ALL_SKIP_MPI_TEST = demo_hyperelasticity_mpi demo_elastodynamics_mpi
+ARCH_ALL_SKIP_MPI_TEST = demo_hyperelasticity_mpi demo_elastodynamics_mpi demo_mixed-poisson_mpi
 
 # Some arches fail the same MPI tests
 # e.g. cahn-hilliard, navier-stokes, elasticity, fails or exceeds allowed time

## dolfin 2019.2.0~git20221205.588d3ac

=== debian/changelog ===
dolfin (2019.2.0~git20221205.588d3ac-2) unstable; urgency=medium

  * add debian patches
    - matplotlib3.6.patch uses plt.axes directly to access 3D axes.
      gca() no longer takes arguments in matplotlib 3.6, only handles
      2D plots. Also fixes 3D quiver plots. Closes: #1027170.
    - debian_version_id.patch sets git_commit_hash to
      DEBIAN_VERSION_ID (os ID from /etc/os-release with debian
      version) rather than leaving as "unknown" (since built from
      tarball source not git source).
    - update test_float128.patch to use float,int,long instead of
      deprecated (removed) numpy.float,numpy.int,numpy.long. Replace
      deprecated np.[u]int0 with np.[u]intp. Closes: #1027190.
  * Standards-Version: 4.6.2

 -- Drew Parsons <dparsons@debian.org>  Fri, 06 Jan 2023 16:25:49 +0100

dolfin (2019.2.0~git20221205.588d3ac-1) unstable; urgency=medium

  * New upstream snapshot
    - applies debian patches fix_ftbfs.patch
      and test_import_ufl_2022.patch
  * debian/tests: specify bash shell in cpp tests to ensure the
    echo -e flag is available (to enable backslash escapes)

 -- Drew Parsons <dparsons@debian.org>  Fri, 09 Dec 2022 01:16:45 +0100

dolfin (2019.2.0~git20220407.d29e24d-8) unstable; urgency=medium

  * debian/tests: reorganise python unit tests to be skipped using
    shell arrays. Helps ensure armel skips test_mixed_assembly_rank0
    Likewise organise skipped python demos using shell arrays.

 -- Drew Parsons <dparsons@debian.org>  Sun, 11 Sep 2022 11:43:00 +0200

dolfin (2019.2.0~git20220407.d29e24d-7) unstable; urgency=medium

  * debian/tests: add armel to the list of arches skipping
    test_mixed_assembly_rank0 in python unit tests

 -- Drew Parsons <dparsons@debian.org>  Sat, 10 Sep 2022 10:32:35 +0200

## dolfin 2019.2.0~git20230116.bd54183

=== io/CMakeLists.txt ===
set(HEADERS
  base64.h
  dolfin_io.h
  Encoder.h
  File.h
  GenericFile.h
  HDF5Attribute.h
  HDF5File.h
  HDF5Interface.h
  HDF5Utility.h
  RAWFile.h
  SVGFile.h
  VTKFile.h
  VTKWriter.h
  X3DFile.h
  X3DOM.h
  XDMFFile.h
  XMLArray.h
  XMLFile.h
  XMLFunctionData.h
  XMLMeshFunction.h
  XMLMesh.h
  XMLMeshValueCollection.h
  XMLParameters.h
  XMLTable.h
  xmlutils.h
  XMLVector.h
  XYZFile.h
  PARENT_SCOPE)

set(SOURCES
  base64.cpp
  File.cpp
  GenericFile.cpp
  HDF5Attribute.cpp
  HDF5File.cpp
  HDF5Interface.cpp
  HDF5Utility.cpp
  pugixml.cpp
  RAWFile.cpp
  SVGFile.cpp
  VTKFile.cpp
  VTKWriter.cpp
  X3DFile.cpp
  X3DOM.cpp
  XDMFFile.cpp
  XMLFile.cpp
  XMLFunctionData.cpp
  XMLMesh.cpp
  XMLParameters.cpp
  XMLTable.cpp
  xmlutils.cpp
  XMLVector.cpp
  XYZFile.cpp
  PARENT_SCOPE)

=== debian/changelog ===
dolfin (2019.2.0~git20230116.bd54183-2) unstable; urgency=medium

  * debian/tests: armhf debci started running out of disk space
    compiling some forms, so skip test_form,
    test_evaluate_dofs_manifolds_affine,
    test_butcher_schemes_vector[ForwardEuler-True]

 -- Drew Parsons <dparsons@debian.org>  Sun, 26 Feb 2023 11:33:10 +0100

dolfin (2019.2.0~git20230116.bd54183-1) unstable; urgency=medium

  * New upstream snapshot
    - provides fixes for mixed-dimensional

 -- Drew Parsons <dparsons@debian.org>  Wed, 15 Feb 2023 16:51:16 +0100

=== debian/control ===
--- 
+++ 
@@ -53,7 +53,7 @@
  graphviz,
  libjs-mathjax,
  libjs-modernizr
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: http://fenicsproject.org
 Vcs-Git: https://salsa.debian.org/science-team/fenics/dolfin.git
 Vcs-Browser: https://salsa.debian.org/science-team/fenics/dolfin

=== debian/rules ===
--- 
+++ 
@@ -1,12 +1,16 @@
 #!/usr/bin/make -f
 
 include /usr/share/dpkg/architecture.mk
+
+OS_ID := $(shell grep -E "^ID" /etc/os-release | sed "s/^ID=//")
 
 DEB_SOURCE_PACKAGE := $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
 DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
 DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
 DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
 DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/\+dfsg.*$$//p')
+
+DEBIAN_VERSION_ID := $(OS_ID)_$(DEB_VERSION)
 
 FENICS_RELEASE_VERSION=$(DEB_STRIPPED_UPSTREAM_VERSION)
 FENICS_MAJOR_VERSION=$(shell echo $(FENICS_RELEASE_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
@@ -141,5 +145,3 @@
 ifeq (armel, $(DEB_HOST_ARCH))
   ARCH_SPECIFIC_SKIP_SERIAL_TEST_64 += demo_contact-vi-snes_serial
 else ifeq (armhf, $(DEB_HOST_ARCH))
-  ARCH_SPECIFIC_SKIP_SERIAL_TEST_64 += demo_contact-vi-snes_serial
-else ifeq (mipsel, $(DEB_HOST_ARCH))

## dolfin 2019.2.0~legacy20230609.8b85e9d.ar

=== debian/changelog ===
dolfin (2019.2.0~legacy20230609.8b85e9d.ar-4) unstable; urgency=medium

  * source-only upload to migrate to testing

 -- Drew Parsons <dparsons@debian.org>  Wed, 09 Aug 2023 17:17:45 +0200

dolfin (2019.2.0~legacy20230609.8b85e9d.ar-3) unstable; urgency=medium

  * gcc-13 patches alter the ABI, so add gcc13 suffix to sonames.
    Closes: #1041705.

 -- Drew Parsons <dparsons@debian.org>  Mon, 24 Jul 2023 20:41:21 +0200

dolfin (2019.2.0~legacy20230609.8b85e9d.ar-2) unstable; urgency=medium

  * debian patch gcc13.patch enables build with gcc-13
    - apply dolfinx PR#2646 to use int instead of std::int32_t
      in timing.h
    - elsewhere #include <cstdint> to define std::int32_t
    - Closes: #1037622

 -- Drew Parsons <dparsons@debian.org>  Thu, 20 Jul 2023 19:58:06 +0200

dolfin (2019.2.0~legacy20230609.8b85e9d.ar-1) unstable; urgency=medium

  * snapshot of upstream ufl_legacy branch
    - source tarball generated with git archive to catch git-lfs files
    - applies debian ufl_legacy renaming patches
  * document use of ufl_legacy in debian/NEWS and in README.Debian.
    Install README.Debian in libdolfin-dev, python3-dolfin, dolfin-doc.
  * debian patch docstring_not_byte.patch fixes docstring. The byte
    string broke pytest 7.3 (PYTEST_DONT_REWRITE). Thanks Timo Röhling.
    Closes: #1038883.

 -- Drew Parsons <dparsons@debian.org>  Sun, 25 Jun 2023 13:24:37 +0200

dolfin (2019.2.0~git20230116.bd54183-3) experimental; urgency=medium

  * UFL 2023.1 has diverged and breaks dolfin.
    debian patches rename_ufl_legacy.patch, test_ufl_legacy.patch
    and demo_ufl_legacy.patch rename ufl as ufl_legacy providing the
    last compatible UFL 2022.2. Depends: python3-ufl-legacy.
    Build-Depends: python3-ffc (>= 2019.2.0~git20210714.a20cbe7-4~),
    python3-ufl-legacy (>= 1:2022.2.0-3~)

 -- Drew Parsons <dparsons@debian.org>  Wed, 26 Apr 2023 18:21:52 +0200

=== debian/control ===
--- 
+++ 
@@ -42,8 +42,9 @@
  pkg-config, python3-pkgconfig,
  python3-all-dev,
  python3-pkg-resources,
- python3-ffc (>= 2019.2), python3-ffc (<< 2019.3),
+ python3-ffc (>= 2019.2.0~git20210714.a20cbe7-4~), python3-ffc (<< 2019.3),
  python3-dijitso (>= 2019.2), python3-dijitso (<< 2019.3),
+ python3-ufl-legacy (>= 1:2022.2.0-3~),
  python3-numpy,
  python3-ply,
  python3-sphinx
@@ -76,7 +77,7 @@
  libboost-serialization-dev,
  libboost-thread-dev,
  libboost-timer-dev,
- libdolfin2019.2 (= ${binary:Version}),
+ libdolfin2019.2gcc13 (= ${binary:Version}),
  libeigen3-dev,
  libhdf5-mpi-dev,
  libsuitesparse-dev,
@@ -151,7 +152,7 @@
  This is the legacy version of DOLFIN, you may want to install the
  next-generation libdolfinx-dev (DOLFIN-X) instead.
 
-Package: libdolfin2019.2
+Package: libdolfin2019.2gcc13
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -173,8 +174,8 @@
 Architecture: any
 Depends: python3-dolfin-real | python3-dolfin64-real,
  python3-dijitso (>= ${fenics:Upstream-Version}), python3-dijitso (<< ${fenics:Next-Upstream-Version}),
- python3-ffc (>= ${fenics:Upstream-Version}), python3-ffc (<< ${fenics:Next-Upstream-Version}),
- python3-ufl (>= ${fenics:Upstream-Version}),
+ python3-ffc (>= 2019.2.0~git20210714.a20cbe7-4~),
+ python3-ufl-legacy (>= 1:2022.2.0-3~),
  python3-numpy,
  ${python3-petsc4py:Depends},
  python3-ply,
@@ -208,7 +209,7 @@
 Architecture: any
 Depends:
  libdolfin-dev (= ${binary:Version}),
- libdolfin2019.2 (= ${binary:Version}),
+ libdolfin2019.2gcc13 (= ${binary:Version}),
  ${python3-petsc4py-real:Depends},
  ${misc:Depends},
  ${python3:Depends},
@@ -247,7 +248,7 @@
  libboost-serialization-dev,
  libboost-thread-dev,
  libboost-timer-dev,
- libdolfin64-2019.2 (= ${binary:Version}),
+ libdolfin64-2019.2gcc13 (= ${binary:Version}),
  libeigen3-dev,
  libhdf5-mpi-dev,
  libsuitesparse-dev,
@@ -272,7 +273,7 @@
  This is the legacy version of DOLFIN, you may want to install the
  next-generation libdolfinx-dev (DOLFIN-X) instead.
 
-Package: libdolfin64-2019.2
+Package: libdolfin64-2019.2gcc13
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -295,7 +296,7 @@
 Architecture: any
 Depends:
  libdolfin64-dev (= ${binary:Version}),
- libdolfin64-2019.2 (= ${binary:Version}),
+ libdolfin64-2019.2gcc13 (= ${binary:Version}),
  ${python3-petsc4py-64-real:Depends},
  ${misc:Depends},
  ${python3:Depends},
@@ -344,4 +345,3 @@
  python3-dolfin (>= ${source:Version}),
  ${misc:Depends},
  ${python3:Depends}
-Description: Executable scripts for DOLFIN
